/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.models.tipo_ingreso;

import danielcortes.xyz.data.SQLiteConnectionHolder;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

public class SQLiteTipoIngresoDAO extends TipoIngresoDAO {
    private static final Logger LOGGER = Logger.getLogger(SQLiteTipoIngresoDAO.class.getName());

    public SQLiteTipoIngresoDAO() {
        this.connectionHolder = new SQLiteConnectionHolder();
    }

    @Override
    public List<TipoIngreso> findAll() {
        List<TipoIngreso> tiposIngresoList = new ArrayList<>();
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from tipos_ingreso";
            PreparedStatement ps = conn.prepareStatement(query);
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0}", query);

            tiposIngresoList = this.tiposIngresoFromResultSet(rs);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return tiposIngresoList;
    }

    @Override
    public List<TipoIngreso> findById(int id) {
        List<TipoIngreso> tiposIngresoList = new ArrayList<>();
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from tipos_ingreso where id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, id);
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}", new Object[]{query, id});

            tiposIngresoList = this.tiposIngresoFromResultSet(rs);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return tiposIngresoList;
    }

    @Override
    public List<TipoIngreso> findByNombre(String nombre) {
        List<TipoIngreso> tiposIngresoList = new ArrayList<>();
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from tipos_ingreso where nombre = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setString(1, nombre);
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}", new Object[]{query, nombre});

            tiposIngresoList = this.tiposIngresoFromResultSet(rs);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return tiposIngresoList;
    }

}
